﻿--VERSION 0.0.17
--DATE 21 09 2014

local RLRMLFrame = CreateFrame("Frame") -- creating  the addon frame
RLRMLFrame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
RLRMLFrame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
RLRMLFrame:RegisterEvent("PARTY_LOOT_METHOD_CHANGED"); -- Fired when about to log out
RLRMLFrame:SetScript("OnEvent",RLRMLFrame.OnEvent) --probably sets script so that when an event fires, the function below is ran?

function RLRMLFrame:OnEvent(event,arg1,arg2,arg3,arg4) -- function pertaining to the frame that checks addon being loaded (probably very wrong to do it like this)-- FORMER (WORKING) VERSION, REVERT IF NEW ONE DOESN´T WORK
 	--if event == "PARTY_LOOT_METHOD_CHANGED" then --REMOVING THESE FROM RLRML AND LEAVING THEM IN RLR ONLY
	--RLRMLFunctions.CheckLootMethod()
	--elseif event == "CHAT_MSG_ADDON" and arg1 ~= "RLRRoll" then  --DEBUG
	--	print("event= ",event,",arg1= ",arg1,",arg2=",arg2,",arg3=",arg3,",arg4=",arg4) --DEBUG
	if event == "ADDON_LOADED" and arg1 == "RankedLootRollML" then --checking that the addon being loaded is this one
			RLRMLFunctions.Initialize()
			local method, partyMaster, raidMaster = GetLootMethod()
			if partyMaster==0 then 
				RLRMLFrame:RegisterEvent("CHAT_MSG_ADDON"); -- Fired when about to log out
				RLRMLFrame:RegisterEvent("OPEN_MASTER_LOOT_LIST") -- Fired when starting master looter
			end
			--OptionsFrame:Hide()
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRRoll" then
			RLRMLFunctions.ProcessRoll(arg1,arg2,arg3,arg4)

	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRBid" then
			RLRMLFunctions.ProcessBid(arg1,arg2,arg3,arg4)

			 
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRActiveRolls" then
			RLRMLFunctions.GetActiveRolls(arg4)
			
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRNuke" then
			RLRMLFunctions.Nuke()
			
	elseif event == "CHAT_MSG_ADDON" and arg1 == "RLRRequestRSync" then
	RLRMLFunctions.SendGuildRankSync(arg4)
			
	elseif event == "OPEN_MASTER_LOOT_LIST" then
		RLRMLFunctions.LootInfo()
		
	elseif event == "PARTY_LOOT_METHOD_CHANGED" then
		
		if RLRMLFirstRun== nil then -- if FirstRun loading of defaults had not occured yet
		print ("DEBUG RLRML 40: running GuildRankRollDefaults")
		RLRMLFunctions.GuildRankRollDefaults()	
		end

		local method, partyMaster, raidMaster = GetLootMethod()
		
		if (partyMaster==0 or raidMaster==0 and UnitInParty("Player")~=nil) then  
			if  GetCVar("autoLootDefault")=="1" then
				message ("You are currently the master looter - turning off Autoloot to prevent it from interfering with loot distribution")
				SetCVar( "autoLootDefault", "0")
				--set autoLootDefault="0"
				RLRMLSavedData["autoloot"]="off"
			end
			
			print("RLRML DEBUG 50: Player set as Master Looter - activating RankedLootRoll-MasterLooter")
			RLRMLFrame:RegisterEvent("CHAT_MSG_ADDON"); -- 
			RLRMLFrame:RegisterEvent("OPEN_MASTER_LOOT_LIST") -- Fired when starting loot distribution as a ML
			
		else
				 if RLRMLFrame:IsEventRegistered("CHAT_MSG_ADDON") then
					if RLRMLSavedData["autoloot"]=="off" then
						RLRMLSavedData["autoloot"]=nil
						SetCVar( "autoLootDefault", "1")
						--set autoLootDefault="1"
						print ("RLRML DEBUG 68 - setting autoloot back on.")
					end
					RLRMLFrame:UnregisterEvent("CHAT_MSG_ADDON"); -- If you´re not the master looter, don´t listen to addon messages
					RLRMLFrame:UnregisterEvent("OPEN_MASTER_LOOT_LIST") -- and don´t do anything with master looter list
					print ("RLRML DEBUG 57: Player no longer Master Looter, deactivating RankedLootRoll-MasterLooter")
				end
		end
	end
	end


	
RLRMLFunctions = {} -- making a table for storing functions
local RLRMLFunctions = RLRMLFunctions -- because of the tip that local functions are accessed faster (I still don´t understand why exactly this works though)
RLRMLFunctionsSave=RLRMLFunctions
RLRMLSessionLoot = {} -- for stuff I don´t need to save, but want to access between RLR and RLRML
RLRMLGuildRanks={}
RLRMLHistory={}
RLRMLSavedData={} -- used for static stuff like version info etc 
RLRMLSavedData.Version=0017
RLRMLSuicideKings={}
 

function RLRMLFunctions.Test()
RLRMLFunctions.SuicideBroadcast()
end

function RLRMLFunctions.Initialize()
	print ("RLRML main lua file v 0.0.16 loaded properly")
	RegisterAddonMessagePrefix("RLRRoll")
	RegisterAddonMessagePrefix("RLR")
	RegisterAddonMessagePrefix("RLRReply")
	RegisterAddonMessagePrefix("RLRItemLink")
	RegisterAddonMessagePrefix("RLRRequestRSync")
	RegisterAddonMessagePrefix("RLRBid")
	RegisterAddonMessagePrefix("RLRNuke")
	RegisterAddonMessagePrefix("RLRActiveRolls")
	
end
 
	
function RLRMLFunctions.Strip(cname) 
  return string.gsub(cname, "%W", "")
end

RLRMLFunctions.Checksum = function(text)
	local counter = 1
	local len = string.len(text)
	for i=1,len do
		counter = counter + string.byte(text, i)*math.pow(31, len- i)
	end
	counter = math.fmod(counter, 7919)
	return string.format("%06x", counter)
end

function RLRMLFunctions.Nuke()
-- wipe (RLRMLGuildRanks)
-- wipe (RLRMLFirstRun)
-- wipe (RLRMLHistory)
-- wipe (RLRMLSavedData)
-- wipe (RLRMLDebugStrings)
-- wipe (RLRMLSuicideKings)
-- ReloadUI();
end

function RLRMLFunctions.SuicideBroadcast()
RLRSKmessage="_"
	for k,v in pairs (RLRMLSuicideKings) do
			RLRSKmessage=strjoin(";",RLRSKmessage,k)
			RLRSKmessage=strjoin("-",RLRSKmessage,v)
			--print ("RLRML DEBUG 162 - i=",i," sKmessage=",skmessage)
				
			if strlen(RLRSKmessage)>80 then 
				print ("RLRML DEBUG 155 - RLRSKmessage sent contains ",strlen(RLRSKmessage),"characters.")
				print ("RLRML DEBUG 157 - RLRSKmessage=",RLRSKmessage)
				SendAddonMessage("RLRMLSuicideBC",RLRSKmessage, "RAID")
				RLRSKmessage="_"
			end
		--print (RLRSKmessage)
	end
	print ("RLRML DEBUG 155 - RLRSKmessage sent contains ",strlen(RLRSKmessage),"characters.")
	print ("RLRML DEBUG 157 - RLRSKmessage=",RLRSKmessage)
	SendAddonMessage("RLRMLSuicideBC",RLRSKmessage, "RAID")
	RLRSKmessage=nil
end



function RLRMLFunctions.ConcatRealmName(name,realm)
	if realm then name=strjoin ("-",name,realm)
	end
	print ("RLRML DEBUG:returning name for ConcatRealmName")
	return name
end

function RLRMLFunctions.RealmDateTime()
local weekday, month, day, year = CalendarGetDate();
local hours,minutes = GetGameTime();
--print ("RLRML DEBUG 148- weekday, month, day, year, hours, minutes =",weekday, month, day, year, hours, minutes)
local RealmDateTime=strjoin("",year, month, day, year, hours, minutes)
--print ("RLRML DEBUG 149",RealmDateTime)
return RealmDateTime
end

function RLRMLFunctions.RemoveTableValue(table,value)
	for k,v in pairs(table) do
		if v==value then v=nil print("RLRML DEBUG 142 removed value ",value,"from table ",table)
		else print ("RLRML DEBUG 142 different value here, not deleting it YET")
		end
	end
end

function RLRMLFunctions.Disenchant(ButtonName)
do
	local LootItemGUID,rollframe=strsplit(";",ButtonName)
	local li=_G[LootItemGUID.."Table"].index
	
	if RLRMLSavedData.Disenchanter==nil then RLRMLSavedData.Disenchanter=GetUnitName("Player") end -- if no master loot disenchanter is selected, give item to master looter
	
	print ("RLRML DEBUG 161 - RLRMLSavedData.Disenchanter=",RLRMLSavedData.Disenchanter)
	
			for ci = 0, GetNumGroupMembers() do
					if 	GetMasterLootCandidate(_G[LootItemGUID.."Table"].index,ci)==RLRMLSavedData.Disenchanter then 
						RLRMLSavedData.DisenchanterID=ci
					end
				end
						
	if RLRMLSavedData.DisenchanterID ~=nil then
		print ("RLRML DEBUG 181: DisenchanterID=",RLRMLSavedData.DisenchanterID)
		GiveMasterLoot(li,RLRMLSavedData.DisenchanterID)
		SendAddonMessage("RLRAwarded",LootItemGUID..";".."Disenchanter"..";".._G[LootItemGUID.."Table"].lootName..";".._G[LootItemGUID.."Table"].itemlink..";".._G[LootItemGUID.."Table"].index..";".._G[LootItemGUID.."Table"].itemLevel..";".."disenchanted","RAID")
	_G[LootItemGUID..";RollFrame"]:Hide()
	end
	end
end

 function RLRMLFunctions.tRemoveByVal(table, value)
   for k,v in pairs(table) do
     if(v==value) then
       tremove(table, k);
     end
   end
 end



function RLRMLFunctions.AwardLoot(ButtonName)

do
	local LootItemGUID,rollframe=strsplit(";",ButtonName)
	local realmDateTime=RLRMLFunctions.RealmDateTime()
--	print ("RLRML DEBUG 156: LootItemGUID=",LootItemGUID)
	local li=_G[LootItemGUID.."Table"].index
		
		for ci = 0,GetNumGroupMembers() do
	--		print ("RLRML TEMPORARY DEBUG 239 -  printing people eligible for loot:",GetMasterLootCandidate(_G[LootItemGUID.."Table"].index,ci))
			 if (GetMasterLootCandidate(_G[LootItemGUID.."Table"].index,ci) == _G[LootItemGUID.."Table"].HighestSender) then
			 		GiveMasterLoot(li, ci);
					RLRMLFunctions.tRemoveByVal(RLRMLActiveRolls,LootItemGUID)
					local realmDateTime=RLRMLFunctions.RealmDateTime()
					_G[LootItemGUID.."Table"].AwardedTo=_G[LootItemGUID.."Table"].HighestSender
					SendAddonMessage("RLRAwarded",LootItemGUID..";".._G[LootItemGUID.."Table"].AwardedTo..";".._G[LootItemGUID.."Table"].lootName..";".._G[LootItemGUID.."Table"].itemlink..";".._G[LootItemGUID.."Table"].index..";".._G[LootItemGUID.."Table"].itemLevel..";".._G[LootItemGUID.."Table"].HighestCurrentItemLink..";".._G[LootItemGUID.."Table"].HighestCurrentItemLevel..";".._G[LootItemGUID.."Table"].HighestRollType..";".._G[LootItemGUID.."Table"].GuildRankName..";".._G[LootItemGUID.."Table"].randomn,"RAID")
		--			tinsert (RLRMLHistory,realmDateTime..";"..LootItemGUID)
					RLRMLHistory[realmDateTime..";"..LootItemGUID]={}
				if RLRMLHistory[realmDateTime..";"..LootItemGUID] then
						tinsert(RLRMLHistory[realmDateTime..";"..LootItemGUID],_G[LootItemGUID.."Table"].HighestSender)
						tinsert(RLRMLHistory[realmDateTime..";"..LootItemGUID],_G[LootItemGUID.."Table"].lootName)
						tinsert(RLRMLHistory[realmDateTime..";"..LootItemGUID],_G[LootItemGUID.."Table"].itemLink)
						tinsert(RLRMLHistory[realmDateTime..";"..LootItemGUID],date())
						tinsert(RLRMLHistory[realmDateTime..";"..LootItemGUID],_G[LootItemGUID.."Table"].itemLevel)
					end
				if _G[LootItemGUID.."Table"].HighestRollType=="BidMS" or _G[LootItemGUID.."Table"].HighestRollType=="BidOS" then
					local name=_G[LootItemGUID.."Table"].HighestSender
					print ("RLRML DEBUG 217 - suicidist=",name)
					RLRMLSuicideKings[name]=0
					end
				end			
			end
		
	if RLRMLHistory[realmDateTime..";"..LootItemGUID]==nil then print ("RLRML DEBUG 194: No loot was awarded. This might be caused by the Master looter moving from the corpse while rolling - do not do that - if you move too far from corpse or close the blizz loot frame, it breaks the function GetMasterLootCandidate! (if you are sure you didn´t do that, please let Gonerill-Frostmane(EU) know what happened and include as much detail as you can remember. ") end

end
end

function RLRMLFunctions.SendGuildRankSync(asker)
	for k,v in pairs(RLRMLGuildRanks) do
		if type(RLRMLGuildRanks[v])=="table" then
			local rollmin,rollmax=unpack(RLRMLGuildRanks[v])
			SendAddonMessage("RLRSendRSync",k..";"..v..";"..rollmin..";"..rollmax,"WHISPER",asker)
		end
	end
end


function RLRMLFunctions.GetActiveRolls(asker)
	print("RLRML DEBUG 295 - asker=",asker)
	for k,v in pairs(RLRML.ActiveRolls) do
			if asker then --need to add a check if there is k roll for that GUID/PLAYER
			local LootMessage=strjoin(";",_G[LootItemGUID.."Table"].index,_G[LootItemGUID.."Table"].lootName,_G[LootItemGUID.."Table"].lootIcon,_G[LootItemGUID.."Table"].itemlink,_G[LootItemGUID.."Table"].itemLevel,_G[LootItemGUID.."Table"].itemEquipLoc,_G[LootItemGUID.."Table"].randomn)
			SendAddonMessage("RLRItemLink",LootMessage,"WHISPER",asker);
			end
		end
	end

function RLRMLFunctions.LootItemGUID(LootMessage)
	local cs = RLRMLFunctions.Checksum(LootMessage) -- cleaning the loot master name and adding RLRMLFunctions.Checksum to create unique channel name
	local LootID = RLRMLFunctions.Strip(LootMessage)
	local LootID = string.sub(LootID, 1, 8)
	local LootItemGUID = strjoin("","RLR",LootID,cs)
	--print ("RLRML DEBUG 146: LootItemGUID=",LootID) --APPARENTLY, THIS IS WORKING (THOUGH A BIT DIFFERENTLY THAN EXPECTED, SINCE LootMessage starts with item icon path, so all names contain a variation on Interface\\Icons...
	return LootItemGUID
	end

function RLRMLFunctions.tablecopy(sourcetable, targettable)
	for k,v in pairs(sourcetable) do
	 targettable[k] = v
	end
return targettable
end

function RLRMLFunctions.GuildRankRollDefaults()
if IsInGuild()
   then do
	RLRMLGuildRanks={}
	wipe (RLRMLGuildRanks)
		for i=1,10 do
		local GuildRankName=GuildControlGetRankName(i)
		local GuildRankName=strjoin("-",i,GuildRankName)
		--print ("RLRML DEBUG 234:GuildRankName=",GuildRankName) -- good for debugging!
		tinsert(RLRMLGuildRanks,GuildRankName)
		RLRMLGuildRanks[GuildRankName]={}
		local rollmin=500-(i*50)
		local rollmax=1000-(i*90)
		tinsert(RLRMLGuildRanks[GuildRankName],rollmin)
		tinsert(RLRMLGuildRanks[GuildRankName],rollmax)
		RLRMLFirstRun=true
		end
		RLRMLGuildRanks["Major"]=400
		RLRMLGuildRanks["Minor"]=100
		RLRMLGuildRanks["OffSpec"]=0
		RLRMLGuildRanks["MajorBid"]=300
		RLRMLGuildRanks["MinorBid"]=0
		RLRMLGuildRanks["Pass"]=-10000
	end
	else
	--print ("RLRML DEBUG 258: You cannot set guild rank roll range defaults while you are not in a guild. While this does not bug out, it sets no values either.")
	end
end


function RLRMLFunctions.FirstRun() -- LOADING DEFAULT VALUES, SETTING GUILD RANKS ETC. - SHOULD IT BE SAVED PER CHARACTER?
print ("You are running RLRML for the first time or the settings file is corrupted, loading default values")
	local PlayerName = UnitName("Player")
	local sname, srealm = strsplit("-",PlayerName)
	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	print ("sender= ",sname,"sguildName = ",sguildName,"sguildRankName= ",sguildRankName,", sguildRankIndex= ",sguildRankIndex) --DEBUG
	--RLRMLDefaults.Guildname=(sguildName)
	--print("Setting ",sguildName," as default guild")
	RLRMLFirstRun=1;
 end
 
 function RLRMLFunctions.CheckLootMethod() 
print ("RLRML DEBUG 287: function RLRMLFunctions.CheckLootMethod() currently serves no purpose(channel joining is handled by RLR")
end 

 
-- SLASH COMMAND FUNCTIONS
function RLRMLFunctions.OptionsPanel() -- RLR Master Looter Options panel
if IsInGuild() == nil then 
	print ("You need to be in a guild to set up guild rank based roll values")

else 
	if _G[strjoin("-",1,GuildControlGetRankName(1))..";1"]==nil then
	print("RLRML DEBUG 337:loading RLRML options");
	RLRMLOptionsFrame:Show()
	
		local rolltypeEditbox = CreateFrame("EditBox", "Major", RLRMLOptionsFrame,"RLRMLRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-106);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("majorfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()
		

		local rolltypeEditbox = CreateFrame("EditBox","Minor", RLRMLOptionsFrame,"RLRMLRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-136);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("minorfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()
		
		local rolltypeEditbox = CreateFrame("EditBox","OffSpec", RLRMLOptionsFrame,"RLRMLRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-166);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("offspecfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()

		local rolltypeEditbox = CreateFrame("EditBox","MajorBid", RLRMLOptionsFrame,"RLRMLRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-216);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("majorbidfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()

		local rolltypeEditbox = CreateFrame("EditBox","MinorBid", RLRMLOptionsFrame,"RLRMLRollTypeTemplate")
		rolltypeEditbox:ClearAllPoints() 
		rolltypeEditbox:SetPoint("TOPLEFT",550,-246);
		rolltypeEditbox:SetTextInsets(0, 0, 0, 0)
		rolltypeEditbox:Show()
		
		local rolltypefs = rolltypeEditbox:CreateFontString("minorbidfs","OVERLAY", "GameFontNormal")
		rolltypefs:SetPoint("TOPLEFT",-80,-10)
		rolltypefs:SetText(rolltypefs:GetParent():GetName())
		rolltypefs:Show()

	for i=1,10 do
		local yoffset=(-71-(i*35))
		local editBoxName=strjoin("-",i,GuildControlGetRankName(i))
		local rollmin,rollmax=unpack(RLRMLGuildRanks[editBoxName])

	
		local editboxmin = CreateFrame("EditBox", editBoxName..";1", RLRMLOptionsFrame,"InputBoxTemplate")
		editboxmin:ClearAllPoints() 
		editboxmin:SetPoint("TOPLEFT",243,yoffset);
		editboxmin:SetSize(40,36) -- Set these to whatever height/width is needed 
		editboxmin:SetText(rollmin)
		editboxmin:SetMaxLetters(5)
		editboxmin:SetAutoFocus(false)
		editboxmin:SetTextInsets(0, 0, 0, 0)
		editboxmin:SetCursorPosition(0)
		editboxmin:SetAttribute("numeric",true)
		
		-- editboxmin:SetScript("OnEnterPressed", function(self)
			-- self:ClearFocus(); -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
			-- local number = self:GetNumber()
			-- print ("RLRML DEBUG 362 - Setting",self:GetName()," to ",number)
		-- end)
	
		editboxmin:SetScript("OnEnterPressed", function(self)
			self:ClearFocus(); -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(RLRMLGuildRanks[rankname],position)
			tinsert(RLRMLGuildRanks[rankname],position,number)
			print ("RLRML DEBUG 362 - Setting",self:GetName()," to ",number)
		end)
		
		editboxmin:SetScript("OnEditFocusLost", function(self)
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(RLRMLGuildRanks[rankname],position)
			tinsert(RLRMLGuildRanks[rankname],position,number)
			print ("RLRML DEBUG 362 - Setting",self:GetName()," to ",number)
		end)
		
		editboxmin:Show()

		local editboxmax = CreateFrame("EditBox", editBoxName..";2", RLRMLOptionsFrame,"InputBoxTemplate")
		editboxmax:ClearAllPoints() 
		editboxmax:SetPoint("TOPLEFT",346,yoffset);
		editboxmax:SetSize(40,36) -- Set these to whatever height/width is needed 
		editboxmax:SetText(rollmax)
		editboxmax:SetMaxLetters(5)
		editboxmax:SetAutoFocus(false)
		editboxmax:SetTextInsets(0, 0, 0, 0)
		editboxmax:SetCursorPosition(0)
		editboxmax:SetAttribute("numeric",true)
		
		editboxmax:SetScript("OnEnterPressed", function(self)
			self:ClearFocus(); -- clears focus from editbox, (unlocks key bindings, so pressing W makes your character go forward.
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(RLRMLGuildRanks[rankname],position)
			tinsert(RLRMLGuildRanks[rankname],position,number)
			print ("RLRML DEBUG 362 - Setting",self:GetName()," to ",number)
		end)

		editboxmax:SetScript("OnEditFocusLost", function(self)
			local number = self:GetNumber()
			local rankname,position=strsplit(";",self:GetName())
			tremove(RLRMLGuildRanks[rankname],position)
			tinsert(RLRMLGuildRanks[rankname],position,number)
			print ("RLRML DEBUG 362 - Setting",self:GetName()," to ",number)
		end)
		
		editboxmax:Show()		
		
		local ranknamef = CreateFrame("Frame", editBoxName, RLRMLOptionsFrame,GameFontNormal)
		ranknamef:SetPoint("TOPLEFT",75,yoffset-12);
		ranknamef:SetSize(40,36) 
		local rankname = ranknamef:CreateFontString("rankname"..i, RLRMLOptionsFrame, "GameFontNormal")
		rankname:SetPoint("TOPLEFT")
		rankname:SetText(editBoxName)
		rankname:Show()
		end
		
		else 
		if RLRMLOptionsFrame:IsShown() then RLRMLOptionsFrame:Hide() else RLRMLOptionsFrame:Show() end
		end
end
end



function RLRMLFunctions.SavedData(...) -- RLR printing the contents of the table "RLRMLFunctions"
  print ("printing the contents of the table RLRMLSavedData");
  table.foreach(RLRMLSavedData, print) -- Prints the whole table, going to remove this soon
 print ("");
 print ("Now printing the last entry once more, for good measure");
  local RLRTableLength = table.getn(RLRMLSavedData); -- find the size of the table 
  print(RLRMLSavedData,RLRTableLength); -- prints the last entry from the table, but it needs to be converted to string first
  end
   
function RLRMLFunctions.TableOfEligibles(LootItemGUID,index)
print ("RLRML DEBUG 547 (TableOfEligibles function) - LootItemGUID, index are:",LootItemGUID,",",index)
for ci = 1, GetNumGroupMembers() do 
	if GetMasterLootCandidate(index,ci)~=nil then 
	local name, realm=GetMasterLootCandidate(index,ci)
	  tinsert(_G[LootItemGUID.."Table"].eligibles,name) 
	  print ("RLR DEBUG 162 - ci, eligible=",ci,GetMasterLootCandidate(index,ci))
	  end
end
local name=GetLootRollItemInfo(index)
local eligibles=strjoin(",",unpack(_G[LootItemGUID.."Table"].eligibles))
SendAddonMessage("RLREligibles",LootItemGUID..";"..strjoin(",",unpack(_G[LootItemGUID.."Table"].eligibles)),"RAID");
print ("RLRML DEBUG 557 - people eligible to loot ",name,":",eligibles)
end
   
   
 function RLRMLFunctions.GetMLName()
 local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	
	if UnitInParty("Player") == nil then
	print ("DEBUG:Not in a party, sending RLRML comm to self")
	RLRMLName=UnitName("Player")
	
	elseif masterlooterRaidID ~= nil then --I´m in a raid, everything seems to work as intended
	RLRMLName = GetRaidRosterInfo(masterlooterRaidID)
	print("DEBUG:masterlooterRaidID=",masterlooterRaidID)
	print ("DEBUG:Sending RLRML messages to: ",RLRMLName)

	elseif masterlooterRaidID == nil and masterlooterPartyID == 0 and lootmethod == "master" then -- I´m not in a raid and ML is probably myself
	RLRMLName = GetUnitName("Player")
	print("DEBUG:master looter is probably myself?")
	print (RLRMLName)
	
	elseif masterlooterRaidID == nil and masterlooterPartyID ~= 0 and lootmethod == "master" then -- I´m not in a raid, I AM in a party with the masterlooter and ML is probably not myself?
	local temp = strjoin ("","Party",masterlooterPartyID)
	name, realm = UnitName(temp, true)
	RLRMLFunctions.ConcatRealmName(name,realm) -- still not showing realm name though
	print ("DEBUG:Sending RLRML messages to:",name)
	
	elseif lootmethod ~= "master" then
	print ("not using master looter,sending RLRML comm to self")
	RLRMLName=UnitName("Player")
	end
	
	print (RLRMLName,"=RLRMLName")
	return (RLRMLName)
	end
   
-- function RLRMLFunctions.TableSearch(table, item) -- WORKS BUT MIGHT NOT BE NECESSARY... GUILD RANK ROLLVALUES IS b NICELY SORTED BY RANK ID - ANYWAY, 
  -- for index,value in ipairs(table) do 
  -- DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." : "..value)
  -- if value==item 
  -- then print ("value ",value,"=","item ",item)
  -- --RLRMLFunctions.TableSearchInside(item)
  -- local foundit=1
  -- end
  -- if not foundit==1 then print ("value ",value," not found in table",table)
  -- end
-- end
-- end 

function RLRMLFunctions.DebugDump(o) --PRINTS FULL CONTENT OF A TABLE
    if type(o) == 'table' then
        local s = '{ '
        for k,v in pairs(o) do
                if type(k) ~= 'number' then k = '"'..k..'"' end
                s = s .. '['..k..'] = ' .. dump(v) .. ','
        end
        return s .. '} '
    else
		print (o)
        return tostring(o)
		end
end

function RLRMLFunctions.LootInfo()
		--print ("still working at line 295")
		
		if RLRMLActiveRolls==nil then 
			RLRMLActiveRolls={}
			--print ("RLRML DEBUG 358 Creating table ActiveRolls")
		end		
		
		for index = 1, GetNumLootItems() do
			local lootIcon, lootName, lootQuantity, rarity, locked  = GetLootSlotInfo(index);
			local itemlink = GetLootSlotLink(index);

			if 	rarity~= nil and rarity>1 and IsEquippableItem(itemlink)~=nil then -- can later change to a rarity set by ML in options -- BAGS
				local itemlink = GetLootSlotLink(index);
				local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemlink)
				tinsert (RLRMLSessionLoot,lootName..index)
				local randomn=fastrandom(1000,9999)
				local LootMessage=strjoin(";",index,lootName,lootIcon,itemlink,itemLevel,itemEquipLoc,randomn)
				local LootItemGUID=RLRMLFunctions.LootItemGUID(LootMessage)
				local LootMessage=strjoin(";",LootItemGUID,LootMessage)
				--print("RLRML DEBUG 190 LootMessage=",LootMessage)
				SendAddonMessage("RLRItemLink",LootMessage,"RAID");
				tinsert(RLRMLActiveRolls,LootItemGUID)
				RLRMLActiveRolls[LootItemGUID]={}
				tinsert(RLRMLActiveRolls[LootItemGUID],LootMessage)
				 if _G[LootItemGUID.."Table"]==nil then
							_G[LootItemGUID.."Table"]={}
							_G[LootItemGUID.."Table"].GUID=LootItemGUID
							_G[LootItemGUID.."Table"].PlayersRolled={}
							_G[LootItemGUID.."Table"].lootIcon=lootIcon
							_G[LootItemGUID.."Table"].lootName=lootName
							_G[LootItemGUID.."Table"].index=index
							_G[LootItemGUID.."Table"].itemlink=itemlink
							_G[LootItemGUID.."Table"].itemLevel=itemLevel
							_G[LootItemGUID.."Table"].itemEquipLoc=itemEquipLoc
							_G[LootItemGUID.."Table"].randomn=randomn
							_G[LootItemGUID.."Table"].eligibles={}
				end
				RLRMLFunctions.TableOfEligibles(LootItemGUID,index)
			else
				if rarity==4 and IsEquippableItem(itemlink)==nil then
					if RLRMLDebugStrings==nil then RLRMLDebugStrings={} end
					local tierPiece=RLRMLFunctions.CheckForTier(lootName) -- need to check item type before checking for tier!
						if tierPiece~=nil then 
							local itemlink = GetLootSlotLink(index);
							local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemlink)
							local randomn=fastrandom(1000,9999)
							local LootMessage=strjoin(";",index,lootName,lootIcon,itemlink,itemLevel,itemEquipLoc,randomn)
							local LootItemGUID=RLRMLFunctions.LootItemGUID(LootMessage)
							local LootMessage=strjoin(";",LootItemGUID,LootMessage)
							SendAddonMessage("RLRSKItem",LootMessage,"RAID");
							tinsert(RLRMLDebugStrings,tierPiece)
							RLRMLFunctions.SuicideKings(itemName,index)
								if _G[LootItemGUID.."Table"]==nil then
									_G[LootItemGUID.."Table"]={}
									_G[LootItemGUID.."Table"].GUID=LootItemGUID
									_G[LootItemGUID.."Table"].PlayersRolled={}
									_G[LootItemGUID.."Table"].lootIcon=lootIcon
									_G[LootItemGUID.."Table"].lootName=lootName
									_G[LootItemGUID.."Table"].index=index
									_G[LootItemGUID.."Table"].itemlink=itemlink
									_G[LootItemGUID.."Table"].itemLevel=itemLevel
									_G[LootItemGUID.."Table"].itemEquipLoc=itemEquipLoc
									_G[LootItemGUID.."Table"].randomn=randomn
									_G[LootItemGUID.."Table"].eligibles={}
								end
						RLRMLFunctions.TableOfEligibles(LootItemGUID,index)
						end
							local itemlink = GetLootSlotLink(index);
							local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemlink)
							local debugstring=strjoin(" - ","RLRML DEBUG 532-Lootinfo (gathering tier piece info): itemName=",itemName,", itemLink=",itemLink,", itemRarity=",itemRarity,", itemLevel=",itemLevel,", itemMinLevel=",itemMinLevel,", itemType=",itemType,", itemSubType=",itemSubType,", itemStackCount=",itemStackCount,", itemEquipLoc=",itemEquipLoc,", itemSellPrice =",itemSellPrice)
							tinsert(RLRMLDebugStrings,debugstring)
							print ("RLRML DEBUG 532 - details about",itemlink,": ",debugstring)
							end
				end
			end
		end
 
function RLRMLFunctions.SuicideKings(itemName,index)
	for ci = 0, GetNumGroupMembers() do
		local suicideName=GetMasterLootCandidate(index,ci)
			if suicideName~=nil then 
				if RLRMLSuicideKings[suicideName]==nil then RLRMLSuicideKings[suicideName]="0" -- there used to be tinsert (RLRMLSuicideKings,suicideName)  in this line too
				--print("RLRML DEBUG 555: RLRMLSuicideKings[",suicideName,"]=",RLRMLSuicideKings[suicideName])
				else RLRMLSuicideKings[suicideName]=RLRMLSuicideKings[suicideName]+1 
				--print("RLRML DEBUG 555: RLRMLSuicideKings[",suicideName,"]=",RLRMLSuicideKings[suicideName])
			end
		end
	end
end

function RLRMLFunctions.CheckForTier(itemName)
local str1,str2,str3,str4,str5=strsplit(" ",itemName)
	local tiernames=("Vanquisher;Conqueror;Protector;Defender;Champion;Hero")
	if str5~=nil and string.find(tiernames,str5)~= nil then 
	--if str5=="Vanquisher" or str5=="Conqueror" or str5=="Protector" or str5=="Defender" or str5=="Champion"  or str5=="Hero" then
	local tierPiece=strjoin(" ","Tier",str1)
	--print("RLRML DEBUG 554 - tier piece detected:", tierPiece)
	return tierPiece
	end
return TierPiece 
end
 
function RLRMLFunctions.RollType(message)
	if message=="Major" then  modifier =RLRMLGuildRanks["Major"]
	elseif message=="Minor" then  modifier =RLRMLGuildRanks["Minor"]
	elseif message=="OffSpec" then  modifier =RLRMLGuildRanks["OffSpec"]
	elseif message=="BIS" then  modifier =RLRMLGuildRanks["BIS"]
	elseif message=="Pass" then  modifier =-10000
	print (modifier)
	end		
return modifier
end


function RLRMLFunctions.RollWithoutTies(LootItemGUID,rollmin,rollmax)
do
	if type(_G[LootItemGUID.."Table"])~="table" then _G[LootItemGUID.."Table"]={}
	else
	repeat
		local roll=math.random(rollmin,rollmax)
	--	print ("RLRML DEBUG 367, roll=",roll)
		return roll
	until tContains(_G[LootItemGUID.."Table"].Rolls,roll)==nil
	tinsert (_G[LootItemGUID.."Table"],roll)
	return roll
	end
	return roll
end
end


--RLRMLFunctions.k HANDLES THE RECEIVED MESSAGES - CHECKS GUILD STATUS (GUILD, RANK) OF SENDER, TYPE OF ROLL AND FORMS A RANDOM ROLL IN THE APPROPRIATE RANGE

function RLRMLFunctions.ProcessSKBid(prefix,message,distributiontype,sender)
 do
 	local sname, srealm = strsplit("-",sender)
	-- print (sname,"  ",srealm)
	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
	local rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink=strsplit(";",message)
	end
end

function RLRMLFunctions.ProcessBid(prefix,message,distributiontype,sender)
	do
	local sname, srealm = strsplit("-",sender)
	print ("RLRML DEBUG 627", sname,"  ",srealm)
	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
	local rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink=strsplit(";",message)
	local GuildRankName=strjoin("-",sguildRankIndex+1,sguildRankName)
	print ("RLRML DEBUG 652 - GuildRankName=",GuildRankName)
	print ("RLRML DEBUG 634 -hard setting some vars in ProcessBid to avoid errors, gonna have to clean up later")
	local rollmin="-"
	local rollmax="-"
	if _G[LootItemGUID.."Table"].PlayersRolled==nil then -- if table of players who have already rolled doesn´t yet exist, create it
		_G[LootItemGUID.."Table"].PlayersRolled={}
	end

	if tContains(_G[LootItemGUID.."Table"].PlayersRolled,sender)~=nil then 	

		SendChatMessage("RLRML DEBUG 471 - You can only roll once on each item","WHISPER",nil,sender)
	
	else 

	if sguildName==pguildName and pguildName~= nil then
	local bid=RLRMLSuicideKings[sname]
	print ("You are bidding ",bid," on ",_G[LootItemGUID.."Table"].lootName)
	local Reply=strjoin(";",bid,LootItemGUID)
	--print ("RLRML DEBUG 715 - sender,bid,LootItemGUID,rollmin,rollmax,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName=",sender,bid,LootItemGUID,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName) -- nils were: roll, rollmin, rollmax, GuildRankName
	local RaidMessage=strjoin(";",sender,bid,LootItemGUID,rollmin,rollmax,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName)
	SendAddonMessage("RLRRollAnnounce",RaidMessage,"RAID") -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
	--SendAddonMessage("RLRReply",Reply,"WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
	tinsert(_G[LootItemGUID.."Table"].PlayersRolled,sender)
	end
	end
end
end


 function RLRMLFunctions.ProcessRoll(prefix,message,distributiontype,sender)
 do
 	local sname, srealm = strsplit("-",sender)
	-- print (sname,"  ",srealm)
	local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
	local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
	local rolltype,LootItemGUID,cItemName,cItemLevel,cItemLink=strsplit(";",message)
	 
 
 	if _G[LootItemGUID.."Table"].PlayersRolled==nil then -- if table of players who have already rolled doesn´t yet exist, create it
		_G[LootItemGUID.."Table"].PlayersRolled={}
	end

if tContains(_G[LootItemGUID.."Table"].PlayersRolled,sender)~=nil then 	

SendChatMessage("RLRML DEBUG 471 - You can only roll once on each item","WHISPER",nil,sender)

else 

	 if sguildName==pguildName and pguildName~= nil then do--DISABLED FOR TESTING/DEBUGGING, BECAUSE I DON´T HAVE A SECOND CHAR TO TEST WITH IN GUILD (STARTER EDITIONS CAN´T JOIN GUILDS)
		--print("RLRML DEBUG 425, sguildName==pguildName and pguildName~=nil - (",pguildName,",",sguildName)
		local sguildName, sguildRankName, sguildRankIndex = GetGuildInfo(sname)
		local pguildName, pguildRankName, pguildRankIndex = GetGuildInfo("Player")
		local modifier=RLRMLFunctions.RollType(rolltype)
		local GuildRankName=strjoin("-",sguildRankIndex+1,sguildRankName)
		local rollmin, rollmax = unpack(RLRMLGuildRanks[GuildRankName])
		local rollmin=rollmin+modifier
		local rollmax=rollmax+modifier
		local roll=RLRMLFunctions.RollWithoutTies(LootItemGUID,rollmin,rollmax)
--		print ("RLRML DEBUG 394 roll=",roll)
		-- print ("|cFF00FF00",sender, "|r rolls |cFF00FF00",roll, "|r on |cFF0000FF",index,"|r in the range ",rollmin,", ",rollmax)
		local Reply=strjoin(";",roll,LootItemGUID,rollmin,rollmax,rolltype)
		--local RaidMessage=strjoin("",sender," rolls |cFF00FF00", roll,"|r on |cFF0000FF lootitem:",index," |r in the range ",rollmin,", ",rollmax," (",rolltype," upgrade roll)")
		local RaidMessage=strjoin(";",sender,roll,LootItemGUID,rollmin,rollmax,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName)
--		print ("RLRML DEBUG 369 - ProcessRoll-",RaidMessage) -- DEBUG
		SendAddonMessage("RLRRollAnnounce",RaidMessage,"RAID") -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
		SendAddonMessage("RLRReply",Reply,"WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
		tinsert(_G[LootItemGUID.."Table"].PlayersRolled,sender)
	end
	
	else
		-- SendAddonMessage("RLRReply","You cannot roll if you are not in the guild", "WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNTend
		 -- DEBUG ALLOWING NON GUILDIES TO ROLL - DELETE EVERYTHING FROM HERE ON WHEN DONE
		print("RLRML DEBUG 453, sguildName~=pguildName or pguildName==nil - (",pguildName,",",sguildName)
		local rollmin=1
		local rollmax=10
		local roll=math.random(rollmin,rollmax)
		local GuildRankName="unknown"
		local rolltype,LootItemGUID=strsplit(";",message)
		local Reply=strjoin(";",roll,LootItemGUID,rollmin,rollmax,rolltype)
		local RaidMessage=strjoin(";",sender,roll,LootItemGUID,rollmin,rollmax,rolltype,cItemName,cItemLevel,cItemLink,GuildRankName)
		SendAddonMessage("RLRRollAnnounce",RaidMessage,"RAID") -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
		SendAddonMessage("RLRReply",Reply,"WHISPER",sender) -- DEBUG: CHECKING IF EVENT CHAT_MSG_ADDON WILL FIRE IF MESSAGE IS SENT FROM NON-STARTER ACCOUNT
		-- /DEBUG ALLOWING NON GUILDIES TO ROLL
		tinsert(_G[LootItemGUID.."Table"].PlayersRolled,sender)
	end
	 end
	 end
 end
 
  -- SLASH COMMAND
SLASH_RLRML1, SLASH_RLRML2 = '/RLRML', '/rlrml'; 
function SlashCmdList.RLRML(msgfull, editbox)--, editbox)
local msg,par1,par2,par3=strsplit(" ",msgfull)
local msg=strlower(msg)
if msg == 'options' then
RLRMLFunctions.OptionsPanel();
elseif msg == 'test' then
RLRMLFunctions.Test();
elseif msg == 'debug' then
RLRMLFunctions.DebugDump(par1);
 elseif msg == 'history' then
RLRMLFunctions.History();
 elseif msg == 'major' then
RLRMLFunctions.Major();
elseif msg == 'saveddata' then
RLRMLFunctions.SavedData();
elseif msg == 'temp' then --debug only
RLRMLFunctions.temp(); 
elseif msg == 'tablecopy' then --debug only
tablecopy(par1,par2); 
elseif msg == 'guildstatuscheck' then --debug only
RLRMLFunctions.GuildStatusCheck()
elseif msg == 'guildinfo' then --debug only
RLRMLFunctions.GuildRankRollDefaults()
elseif msg == "tableinsert" then 
tinsert(par1,par2,par3)
else
 print("Raid Loot Roll has the following arguments");
 print("/RLRML options for options panel");
 print("/RLRML history for records history");
 print("/RLRML major to perform a major upgrade roll");
 print("/RLRML tableinsert [modifier] to test inserting stuff into table RLRMLSavedData");
 print("/RLRML saveddata to test inserting stuff into table RLRMLSavedData");
 print("/RLRML master to test checking for master looter name");
 print("/RLRML guildstatuscheck to check guild/rank check function")
 print("/RLRML guildinfo to check guild rank / guild rank name check function")
 print("/RLRML temp to run temp function (whatever I´m working on atm)")
   end
end
--WORK IN PROGRESS - SLASH COMMAND



RLRMLFrame:SetScript("OnEvent", RLRMLFrame.OnEvent); -- this is not doing what I want it to do (which is to register the slash command) but if I take it away, the message at line 10 doesn´t fire
 function SlashCmdList.rlr(msg, modifier)
 print("registering slash command /rlr ");
 SLASH_RLR = "/rlr";
 message("registering slash command /rlr ");
 end